var Canvas = require('canvas');
var Chainsaw = require('chainsaw');
var fs = require('fs');

function EtchASketch() {

    //screen dimensions, in pixels
    var width = 640;
    var height = 480;

    //knob "sensitivity"---revolutions of knob to draw width/height
    var sensitivity = 2;

    //The etch-a-sketch colors
    var black = "#000000";
    var white = "#e6e6e6";

    //initializing the canvas n' shit
    var canvas = new Canvas(width, height);
    var pen = canvas.getContext('2d');

    //pen starts in center
    //idk if the current pen posish is accessible from the canvas element.
    var x = Math.floor(width/2);
    var y = Math.floor(height/2);
    pen.moveTo(x, y);

    //shake is used for initializing, too.
    var shake = function() {
        pen.strokeStyle = white;
        pen.fillStyle = white;
        pen.fillRect(0, 0, canvas.width, canvas.height);
    }
Math.floor(width/2),
                Math.floor(height/2)
    shake();
    
    return Chainsaw( function(saw) {

        this.shake = function() {
            console.log('Shake shake shake...');
            shake;
            saw.next();
        }
            
        this.twistRight = function (degrees) {
            console.log('Twisted right knob '+degrees+' degrees!');
            pen.strokeStyle = black;
            pen.fillStyle = black;
            x = Math.round(x - width * degrees/360/sensitivity);
            x = Math.max(0, x);
            x = Math.min(canvas.width, x);
            console.log('Moved pen to ('+x+', '+y+')!');
            pen.lineTo(x,y);
            pen.stroke();
            saw.next();
        }

        this.twistLeft = function (degrees) {
            console.log('Twisted left knob '+degrees+' degrees!');
            pen.strokeStyle = black;
            pen.fillStyle = black;
            y = Math.round(y - height * degrees/360/sensitivity);
            y = Math.max(0, y);
            y = Math.min(canvas.height, y);
            console.log('Moved pen to ('+x+', '+y+')!');
            pen.lineTo(x,y);
            pen.stroke();
            saw.next();
        }

        this.print = function (filename) {
            console.log('Outputting file to '+filename+' !');
            var out = fs.createWriteStream(filename);
            var stream = canvas.createPNGStream();
            stream.on('data', function(chunk) {
                out.write(chunk);
            });
        }

    });
}

module.exports = EtchASketch;
